From e85d67e57f6cb36a8977110f2cbf9383965330a0 Mon Sep 17 00:00:00 2001
From: Guennadi Liakhovetski <g.liakhovetski@gmx.de>
Date: Thu, 12 Apr 2012 15:28:16 +0200
Subject: [PATCH 5/5] DisplayHardware: eliminate a tight infinite loop on vanilla kernels

On kernels, not implementing /sys/power/wait_for_fb_sleep and
/sys/power/wait_for_fb_wake
DisplayHardwareBase::DisplayEventThread::threadLoop() enters a tight
infinite loop, consuming 100% CPU. Prevent this by checking return code of
the open() call.

Change-Id: I703f7ae8ada8c99b372f59f21ef534588afa0628
---
 .../DisplayHardware/DisplayHardwareBase.cpp        |    2 ++
 1 files changed, 2 insertions(+), 0 deletions(-)

diff --git a/frameworks/base/services/surfaceflinger/DisplayHardware/DisplayHardwareBase.cpp b/frameworks/base/services/surfaceflinger/DisplayHardware/DisplayHardwareBase.cpp
index f4afeea..dc63a5c 100644
--- a/frameworks/base/services/surfaceflinger/DisplayHardware/DisplayHardwareBase.cpp
+++ b/frameworks/base/services/surfaceflinger/DisplayHardware/DisplayHardwareBase.cpp
@@ -72,6 +72,8 @@ bool DisplayHardwareBase::DisplayEventThread::threadLoop()
     int fd;
 
     fd = open(kSleepFileName, O_RDONLY, 0);
+    if (fd < 0)
+        return false;
     do {
       err = read(fd, &buf, 1);
     } while (err < 0 && errno == EINTR);
-- 
1.7.2.5

